Attribute VB_Name = "SmallDragon"
Option Explicit

' MsgBox parameters
Global Const MB_OK = 0                               ' OK button only
Global Const MB_OKCANCEL = 1                  ' OK and Cancel buttons
Global Const MB_ABORTRETRYIGNORE = 2  ' Abort, Retry, and Ignore buttons
Global Const MB_YESNOCANCEL = 3            ' Yes, No, and Cancel buttons
Global Const MB_YESNO = 4                         ' Yes and No buttons
Global Const MB_RETRYCANCEL = 5             ' Retry and Cancel buttons

Global Const MB_ICONSTOP = 16                   ' Critical message
Global Const MB_ICONQUESTION = 32           ' Warning query
Global Const MB_ICONEXCLAMATION = 48     ' Warning message
Global Const MB_ICONINFORMATION = 64      ' Information message

Global Const MB_APPLMODAL = 0                   ' Application Modal Message Box
Global Const MB_DEFBUTTON1 = 0                  ' First button is default
Global Const MB_DEFBUTTON2 = 256               ' Second button is default
Global Const MB_DEFBUTTON3 = 512               ' Third button is default
Global Const MB_SYSTEMMODAL = 4096         'System Modal

' MsgBox return values
Global Const IDOK = 1                                       ' OK button pressed
Global Const IDCANCEL = 2                               ' Cancel button pressed
Global Const IDABORT = 3                                 ' Abort button pressed
Global Const IDRETRY = 4                                 ' Retry button pressed
Global Const IDIGNORE = 5                                ' Ignore button pressed
Global Const IDYES = 6                                      ' Yes button pressed
Global Const IDNO = 7                                        ' No button pressed
Global response As Integer                                  'Button value return
Global msg As String                                           'Message

'User profile declarations

Declare Function GetModuleHandle& Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String)
Declare Function WritePrivateProfileString& Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal Appname As String, ByVal Keyname As Any, ByVal Infostring As String, ByVal Config_File As String)
Declare Function GetPrivateProfileString& Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal Appname As String, ByVal Keyname As String, ByVal lpDefault As String, ByVal Returnstring As String, ByVal nSize As Long, ByVal Config_File As String)

'Global constants for file and directory checks

Global sFilename As String
Global sFullPath As String
Global sDirectoryName As String
Global Applname As String
Global FileNo As Integer

'Global constants for Write and Get INI files

Global Returnstring As String * 255
Global SectionName As String
Global Keyname As String
Global INIRet As Integer
Global nSize As Long
Global Infostring As String
Global Config_File As String

'Define colour constants

Global Const Red = &HFF&
Global Const Green = &HFF00&
Global Const Orange = &H80FF&
Global Const Black = &H0&
Global Const Grey = &HC0C0C0
Global Const Yellow = &H80FFFF
Global Const White = &HFFFFFF
Global Const Blue = &HFF0000

'This project's globals

Global FileType As Integer
Global GaugeName As String


Sub ScribbleIt()

If WritePrivateProfileString(ByVal SectionName, ByVal Keyname, ByVal Infostring, ByVal Config_File) = 0 Then
  MsgBox "Unable to write default values.", 48, Keyname
End If

End Sub





Function FileExists(sFilename) As Integer

Dim x As Integer

'Check for the existence of a file by attempting an OPEN.
'sFilename is the pathname passed in

x = FreeFile

On Error Resume Next
Open sFilename For Input As x
If Err = 0 Then
  FileExists = True
Else
  FileExists = False
End If
Close x

End Function



Sub ReadIt()

nSize = 255
Returnstring = ""
INIRet = GetPrivateProfileString(ByVal SectionName, ByVal Keyname, "0", ByVal Returnstring, ByVal nSize, ByVal Config_File)
Infostring = Left$(Returnstring, INIRet)

End Sub




