//REPLACE asi WITH GAUGENAME

char asi_gauge_name[]		= GAUGE_NAME;
extern PELEMENT_HEADER		asi_list;
extern MOUSERECT			asi_mouse_rect[];
GAUGE_CALLBACK				asi_update;
GAUGE_HEADER_FS700(GAUGE_W, asi_gauge_name, &asi_list, asi_mouse_rect, asi_update, 0,0,0 );

FAILURE_RECORD	asi_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_ZERO},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

MOUSE_BEGIN( asi_mouse_rect, 0, 0, 0 )
MOUSE_END

//Maximum/minimum airspeed to be registered

#define GAUGE_MAX_AIRSPEED 160
#define GAUGE_MIN_AIRSPEED 30

//airspeed indication day

NONLINEARITY  asi_needle[] =

{
	{{190,	 8},	 30.000000,  0},
	{{222,	 24},	 40.000000,  0},
	{{254,	 51},	 50.000000,  0},
	{{277,	 93},	 60.000000,  0},
	{{285,	 145},	 70.000000,  0},
	{{274,	 204},	 80.000000,  0},
	{{229,	 259},	 90.000000,  0},
	{{169,	 285},	 100.000000, 0},
	{{97,	 277},	 110.000000, 0},
	{{36,	 235},	 120.000000, 0},
	{{7,	 173},	 130.000000, 0},
	{{13,	 98},	 140.000000, 0},
	{{48,	 39},	 150.000000, 0},
	{{110,	 7},	 160.000000, 0},
};


//airspeed indication night


NONLINEARITY  asi_needle_night[] =

{
	{{190,	 8},	 30.000000,  0},
	{{222,	 24},	 40.000000,  0},
	{{254,	 51},	 50.000000,  0},
	{{277,	 93},	 60.000000,  0},
	{{285,	 145},	 70.000000,  0},
	{{274,	 204},	 80.000000,  0},
	{{229,	 259},	 90.000000,  0},
	{{169,	 285},	 100.000000, 0},
	{{97,	 277},	 110.000000, 0},
	{{36,	 235},	 120.000000, 0},
	{{7,	 173},	 130.000000, 0},
	{{13,	 98},	 140.000000, 0},
	{{48,	 39},	 150.000000, 0},
	{{110,	 7},	 160.000000, 0},
};
//Callbacks to get airspeed from FS

//airspeed needle

NEEDLE_UPDATE_CALLBACK	asi_src_cb_day;
NEEDLE_UPDATE_CALLBACK	asi_src_cb_night;

MODULE_VAR lights_on = {PANEL_LIGHTS};
MODULE_VAR curr_asi = {AIRSPEED};
double asi_ret = 0;

//Day

MAKE_NEEDLE(	asi_ind_needle,
				ASI_NEEDLE,
				NULL,
				asi_fail,
                IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE | anti_alias,
				0,
				175, 175,
				52, 9,
				MODULE_VAR_NONE,
                asi_src_cb_day,
				asi_needle,
				0 )

PELEMENT_HEADER		asi_plist1[] =
{
	&asi_ind_needle.header,
	NULL
};


MAKE_ICON(		asi_face,
				ASI_FACE,
				&asi_plist1,
				NULL,
				IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
				0,
				30,28,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0, )

PELEMENT_HEADER		asi_plist2[] =
{
	&asi_face.header,
	NULL
};

//Night

MAKE_NEEDLE(	asi_ind_needle_night,
				ASI_NEEDLE_NIGHT,
				&asi_plist2,
				asi_fail,
                IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE | IMAGE_HIDDEN | bright | anti_alias,
				0,
				175, 175,
				52, 9,
				MODULE_VAR_NONE,
                asi_src_cb_night,
				asi_needle_night,
				0 )

PELEMENT_HEADER		asi_plist3[] =
{
	&asi_ind_needle_night.header,
	NULL
};

MAKE_ICON(		asi_face_night,
				ASI_FACE_NIGHT,
				&asi_plist3,
				NULL,
				IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE | bright,
				0,
				30,28,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0, )

PELEMENT_HEADER		asi_plist4[] =
{
	&asi_face_night.header,
	NULL
};

//Instrument bezel

MAKE_STATIC(	asi_background,
				ASI_BG,
				&asi_plist4,
				NULL,
				IMAGE_USE_TRANSPARENCY | IMAGE_USE_ERASE,
				0,
				0, 0 )

PELEMENT_HEADER		asi_list	= &asi_background.header;

//---------------------------------------------------------------------------
FLOAT64 FSAPI asi_src_cb_day (PELEMENT_NEEDLE pelement)

{
	lookup_var(&curr_asi);
	asi_ret = curr_asi.var_value.n;
	if ( asi_ret > GAUGE_MAX_AIRSPEED ) asi_ret = GAUGE_MAX_AIRSPEED;
	if ( asi_ret < GAUGE_MIN_AIRSPEED ) asi_ret = GAUGE_MIN_AIRSPEED;

	return asi_ret; 
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI asi_src_cb_night (PELEMENT_NEEDLE pelement)

{
	lookup_var(&curr_asi);
	asi_ret = curr_asi.var_value.n;
	if ( asi_ret > GAUGE_MAX_AIRSPEED ) asi_ret = GAUGE_MAX_AIRSPEED;
	if ( asi_ret < GAUGE_MIN_AIRSPEED ) asi_ret = GAUGE_MIN_AIRSPEED;

	return asi_ret; 
}

//---------------------------------------------------------------------------
void FSAPI	asi_update (PGAUGEHDR pgauge, int service_id, UINT32 extra_data)
{
	switch(service_id)
	{

/* "install_routine()" */

		case    PANEL_SERVICE_PRE_INSTALL:
		break;

/* "initialize_routine()" */

		case    PANEL_SERVICE_PRE_INITIALIZE:

		break;

/* "update_routine()" */

		case    PANEL_SERVICE_PRE_UPDATE:

		lookup_var(&lights_on);

//Daylight

		if (lights_on.var_value.n == 0)
		{
			HIDE_LISTELEMENT(pgauge->elements_list[0],1);
			HIDE_LISTELEMENT(pgauge->elements_list[0],2);

			SHOW_LISTELEMENT(pgauge->elements_list[0],3);
			SHOW_LISTELEMENT(pgauge->elements_list[0],4);

		}
		else
		{
			SHOW_LISTELEMENT(pgauge->elements_list[0],1);
			SHOW_LISTELEMENT(pgauge->elements_list[0],2);

			HIDE_LISTELEMENT(pgauge->elements_list[0],3);
			HIDE_LISTELEMENT(pgauge->elements_list[0],4);
		}

		break;

/* "draw_routine()" */

		case    PANEL_SERVICE_PRE_DRAW:
		break;

/* "kill_routine()" */

		case    PANEL_SERVICE_PRE_KILL:
		break;
	}

}

/////////////////////////////////////////////////////////////////////////////
#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W

