//REPLACE gi106 WITH GAUGENAME

char gi106_gauge_name[]		= GAUGE_NAME;
extern PELEMENT_HEADER		gi106_list;
extern MOUSERECT			gi106_mouse_rect[];
GAUGE_CALLBACK				gi106_update;
GAUGE_HEADER_FS700(GAUGE_W, gi106_gauge_name, &gi106_list, gi106_mouse_rect, gi106_update, 0,0,0 );

FAILURE_RECORD	gi106_fail2[] =
{
	{FAIL_GAUGE_NAVIGATION, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

//******* Day

NONLINEARITY gi106card_needle_nl[] =
{
	{{7,	 125},	  270.000000, 0},
	{{127,	 0},	  180.000000, 0},
	{{250,	 125},	  90.000000, 0},
	{{126,	 243},	  0.000000, 0},
};

//********** Night

NONLINEARITY gi106card_night_needle_nl[] =
{
	{{7,	 125},	  270.000000, 0},
	{{127,	 0},	  180.000000, 0},
	{{250,	 125},	  90.000000, 0},
	{{126,	 243},	  0.000000, 0},
};


MOUSE_FUNCTION gi106_obs_up_mcb;
MOUSE_FUNCTION gi106_obs_dn_mcb;
MOUSE_FUNCTION gi106_degrees_mcb;

MOUSE_BEGIN( gi106_mouse_rect, 0, 0, 0 )

    MOUSE_CHILD_FUNCT( 13, 200, 23, 44, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, gi106_obs_dn_mcb)
    MOUSE_CHILD_FUNCT( 37, 200, 23, 44, CURSOR_UPARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, gi106_obs_up_mcb)
    MOUSE_CHILD_FUNCT( 68, 150, 38, 30, CURSOR_HAND, MOUSE_LEFTSINGLE, gi106_degrees_mcb)

MOUSE_END

SINT32 gi106obs_count = 0;

UINT32 gi106gyro_degrees = 0;
UINT32 gi106show_deg = 0;
UINT32 gi106obs_check = 0;

double gi106_gs = 0;
double gi106_loc = 0;

//****** Day

STRING_UPDATE_CALLBACK gi106deg_string_cb;
NEEDLE_UPDATE_CALLBACK gi106card_needle_cb;
SLIDER_UPDATE_CALLBACK gi106gs_slider_cb;
SLIDER_UPDATE_CALLBACK gi106nav_slider_cb;

//****** Night

STRING_UPDATE_CALLBACK gi106deg_night_string_cb;
NEEDLE_UPDATE_CALLBACK gi106card_night_needle_cb;
SLIDER_UPDATE_CALLBACK gi106gs_night_slider_cb;
SLIDER_UPDATE_CALLBACK gi106nav_night_slider_cb;

NEEDLE_UPDATE_CALLBACK gi106obs_needle_cb;


/*********************** Day display ***************************/


MAKE_ICON(		gi106gsflag_icon,
				GI_GS,
				NULL,
				gi106_fail2,
				hidden | erase | transparent,
				0,
				193,115,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi106_plist1[] =
{
	&gi106gsflag_icon.header,
	NULL
};


MAKE_ICON(		gi106navflag_icon,
				GI_NAV,
				&gi106_plist1,
				gi106_fail2,
				hidden | erase | transparent,
				0,
				115,199,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi106_plist2[] =
{
	&gi106navflag_icon.header,
	NULL
};

//GS needle

MAKE_SLIDER(    gi106gs_slider,
                GI_HORZ,
                &gi106_plist2,
                gi106_fail2,
				hidden | erase | transparent | anti_alias,
                0,
                54, 129,
                MODULE_VAR_NONE, NULL, 0.000000,
                MODULE_VAR_NONE, gi106gs_slider_cb, 0.5 )

PELEMENT_HEADER		gi106_plist3[] =
{
	&gi106gs_slider.header,
	NULL
};

//LOC needle


MAKE_SLIDER(    gi106loc_slider,
                GI_VERT,
                gi106_plist3,
                gi106_fail2,
				hidden | erase | transparent | anti_alias,
                0,
                125, 60,
                MODULE_VAR_NONE, gi106nav_slider_cb, 0.5,
                MODULE_VAR_NONE, NULL, 0.000000)

PELEMENT_HEADER		gi106_plist4[] =
{
	&gi106loc_slider.header,
	NULL
};


MAKE_ICON(		gi106yellowflag_icon,
				GI_POINTER,
				&gi106_plist4,
				NULL,
				hidden | erase | transparent,
				0,
				119,45,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi106_plist5[] =
{
	&gi106yellowflag_icon.header,
	NULL
};


MAKE_ICON(		gi106to_flag_icon,
				GI_TO_FLAG,
				&gi106_plist5,
				gi106_fail2,
				hidden | erase | transparent,
				0,
				156,86,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi106_plist6[] =
{
	&gi106to_flag_icon.header,
	NULL
};


MAKE_ICON(		gi106from_flag_icon,
				GI_FROM_FLAG,
				&gi106_plist6,
				gi106_fail2,
				hidden | erase | transparent,
				0,
				156,86,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi106_plist7[] =
{
	&gi106from_flag_icon.header,
	NULL
};

MAKE_STRING(	gi106deg_string,
				&gi106_plist7,
				NULL,
				erase | string_trans,
				0,
				60, 143,
                50, 30,
				3,
				MODULE_VAR_NONE,
				MODULE_VAR_NONE,
				MODULE_VAR_NONE,
				white,
				trans_black,
				yellow,
				arial,
				normal,
				def_char,
				0,
				DT_CENTER | DT_VCENTER | DT_SINGLELINE,
				NULL,
				gi106deg_string_cb )

PELEMENT_HEADER		gi106_plist8[] =
{
	&gi106deg_string.header,
	NULL
};


MAKE_ICON(		gi106dots_icon,
				GI_GS_DOTS,
				&gi106_plist8,
				NULL,
				hidden | erase | transparent,
				0,
				50,50,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi106_plist9[] =
{
	&gi106dots_icon.header,
	NULL
};

MAKE_NEEDLE(    gi106card_needle,
                GI_GYRO,
                &gi106_plist9,
                NULL,
				erase | transparent | anti_alias,
                0,
                127, 127,
				112, 112,
				AIRSPEED,
				gi106card_needle_cb,
                gi106card_needle_nl,
                0 )

PELEMENT_HEADER		gi106_plist10[] =
{
	&gi106card_needle.header,
	NULL
};

/**************************** Night display ************************/



MAKE_ICON(		gi106gsflag_night_icon,
				GI_GS,
				&gi106_plist10,
				gi106_fail2,
				luminous | hidden | erase | transparent,
				0,
				193,115,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi106_plist11[] =
{
	&gi106gsflag_night_icon.header,
	NULL
};


MAKE_ICON(		gi106navflag_night_icon,
				GI_NAV,
				&gi106_plist11,
				gi106_fail2,
				luminous | hidden | erase | transparent,
				0,
				115,199,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi106_plist12[] =
{
	&gi106navflag_night_icon.header,
	NULL
};

MAKE_SLIDER(    gi106gs_night_slider,
                GI_HORZ,
                &gi106_plist12,
                gi106_fail2,
				luminous | hidden | erase | transparent | anti_alias,
                0,
                54, 129,
                MODULE_VAR_NONE, NULL, 0.000000,
                MODULE_VAR_NONE, gi106gs_night_slider_cb, 0.5)

PELEMENT_HEADER		gi106_plist13[] =
{
	&gi106gs_night_slider.header,
	NULL
};

//LOC needle


MAKE_SLIDER(    gi106loc_night_slider,
                GI_VERT,
                &gi106_plist13,
                gi106_fail2,
				luminous | hidden | erase | transparent | anti_alias,
                0,
                125, 60,
                MODULE_VAR_NONE, gi106nav_night_slider_cb, 0.5,
                MODULE_VAR_NONE, NULL, 0.000000)

PELEMENT_HEADER		gi106_plist14[] =
{
	&gi106loc_night_slider.header,
	NULL
};

MAKE_ICON(		gi106yellowflag_night_icon,
				GI_POINTER,
				&gi106_plist14,
				NULL,
				luminous | hidden | erase | transparent,
				0,
				119,45,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi106_plist15[] =
{
	&gi106yellowflag_night_icon.header,
	NULL
};


MAKE_ICON(		gi106to_flag_night_icon,
				GI_TO_FLAG,
				&gi106_plist15,
				gi106_fail2,
				luminous | hidden | erase | transparent,
				0,
				156,86,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi106_plist16[] =
{
	&gi106to_flag_night_icon.header,
	NULL
};


MAKE_ICON(		gi106from_flag_night_icon,
				GI_FROM_FLAG,
				&gi106_plist16,
				gi106_fail2,
				luminous | hidden | erase | transparent,
				0,
				156,86,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi106_plist17[] =
{
	&gi106from_flag_night_icon.header,
	NULL
};


MAKE_STRING(	gi106deg_night_string,
				&gi106_plist17,
				NULL,
				luminous | erase | string_trans,
				0,
				60, 143,
                50, 30,
				3,
				MODULE_VAR_NONE,
				MODULE_VAR_NONE,
				MODULE_VAR_NONE,
				white,
				trans_black,
				yellow,
				arial,
				normal,
				def_char,
				0,
				DT_CENTER | DT_VCENTER | DT_SINGLELINE,
				NULL,
				gi106deg_night_string_cb )

PELEMENT_HEADER		gi106_plist18[] =
{
	&gi106deg_night_string.header,
	NULL
};


MAKE_ICON(		gi106dots_night_icon,
				GI_GS_DOTS,
				&gi106_plist18,
				NULL,
				luminous | hidden | erase | transparent,
				0,
				50,50,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi106_plist19[] =
{
	&gi106dots_night_icon.header,
	NULL
};


MAKE_NEEDLE(    gi106card_night_needle,
                GI_GYRO,
                &gi106_plist19,
                NULL,
				luminous | hidden | erase | transparent | anti_alias,
                0,
                127, 127,
				112, 112,
				AIRSPEED,
				gi106card_night_needle_cb,
                gi106card_night_needle_nl,
                0 )

PELEMENT_HEADER		gi106_plist20[] =
{
	&gi106card_night_needle.header,
	NULL
};

//Dark background

MAKE_NEEDLE(    gi106obs_needle,
                GI_OBS,
                &gi106_plist20,
                NULL,
				erase | transparent | anti_alias,
                0,
                36, 222,
				20, 20,
				AIRSPEED,			//Dummy for anti-clockwise movement
				gi106obs_needle_cb,
                NULL,
                0 )

PELEMENT_HEADER		gi106_plist21[] =
{
	&gi106obs_needle.header,
	NULL
};

MAKE_STATIC (	gi106_static,
				GI_BG,
				&gi106_plist21,
				NULL,
				erase | transparent,
				0,
				0,0 )

PELEMENT_HEADER	gi106_list	= &gi106_static.header;

//---------------------------------------------------------------------------
//****************** Day callbacks ***********************//
//---------------------------------------------------------------------------
FLOAT64 FSAPI gi106gs_slider_cb (PELEMENT_SLIDER pelement )
{
	lookup_var(&glideslope);
	if (avionics_on == 1) gi106_gs = glideslope.var_value.n;
	else gi106_gs = 0;
	return gi106_gs;
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI gi106nav_slider_cb (PELEMENT_SLIDER pelement )
{
	lookup_var(&deviation);
	if (avionics_on == 1) gi106_loc = deviation.var_value.n;
	else gi106_loc = 0;
	return gi106_loc;
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI gi106card_needle_cb (PELEMENT_NEEDLE pelement )
{
	FLOAT64	val = pelement->source_var.var_value.n;

	return gi106gyro_degrees;
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI	gi106deg_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64	val = pelement->source_var[0].var_value.n;
	val = !val;

	if (gi106show_deg == 1) wsprintf(pelement->string, "%3d", gi106gyro_degrees);
	else wsprintf(pelement->string, "%3s", "");

	return val;
}
//---------------------------------------------------------------------------
//************************** Night callbacks ***********************//
//---------------------------------------------------------------------------
FLOAT64 FSAPI gi106gs_night_slider_cb (PELEMENT_SLIDER pelement )
{
	lookup_var(&glideslope);
	if (avionics_on == 1) gi106_gs = glideslope.var_value.n;
	else gi106_gs = 0;
	return gi106_gs;
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI gi106nav_night_slider_cb (PELEMENT_SLIDER pelement )
{
	lookup_var(&deviation);
	if (avionics_on == 1) gi106_loc = deviation.var_value.n;
	else gi106_loc = 0;
	return gi106_loc;
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI gi106card_night_needle_cb (PELEMENT_NEEDLE pelement )
{
	FLOAT64	val = pelement->source_var.var_value.n;

	return gi106gyro_degrees;
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI	gi106deg_night_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64	val = pelement->source_var[0].var_value.n;
	val = !val;

	if (gi106show_deg == 1) wsprintf(pelement->string, "%3d", gi106gyro_degrees);
	else wsprintf(pelement->string, "%3s", "");

	return val;
}
//---------------------------------------------------------------------------
//************************* External callbacks ***********************//
//---------------------------------------------------------------------------
FLOAT64 FSAPI gi106obs_needle_cb (PELEMENT_NEEDLE pelement )
{
	FLOAT64	val = pelement->source_var.var_value.n;

	return gi106gyro_degrees;
}
//---------------------------------------------------------------------------
BOOL FSAPI gi106_obs_up_mcb( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{
	if (gi106obs_count + 1 > 359) gi106obs_count = 0;
	else gi106obs_count++;

	if (gi106gyro_degrees + 1 > 359) gi106gyro_degrees = 0;
	else gi106gyro_degrees++;

	trigger_key_event(KEY_VOR1_SET, gi106gyro_degrees);

	gi106obs_check = 1;

	return FALSE;
}
//---------------------------------------------------------------------------
BOOL FSAPI gi106_obs_dn_mcb( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{
	if (gi106obs_count - 1 == -1) gi106obs_count = 359;
	else gi106obs_count--;

	if (gi106gyro_degrees - 1 == -1) gi106gyro_degrees = 359;
	else gi106gyro_degrees--;

	trigger_key_event(KEY_VOR1_SET, gi106gyro_degrees);

	gi106obs_check = 1;

	return FALSE;
}
//---------------------------------------------------------------------------
BOOL FSAPI gi106_degrees_mcb( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{

	if (gi106show_deg == 0) gi106show_deg = 1;
	else gi106show_deg = 0;

	return FALSE;
}
//---------------------------------------------------------------------------
void FSAPI	gi106_update (PGAUGEHDR pgauge, int service_id, UINT32 extra_data)
{
	switch(service_id)
	{

/* "install_routine()" */

		case    PANEL_SERVICE_PRE_INSTALL:
		break;

/* "initialize_routine()" */

		case    PANEL_SERVICE_PRE_INITIALIZE:
		break;

/* "update_routine()" */

		case    PANEL_SERVICE_PRE_UPDATE:

//Check for active power buses

			lookup_var(&avionics_circuit_on);
			lookup_var(&navlights_on);
			avionics_on = avionics_circuit_on.var_value.n;
			lights_on = navlights_on.var_value.n;

//Set OBI heading - this checks for a change in the menus too

			lookup_var(&heading);
			vor1_hdg = heading.var_value.n;
			if (vor1_hdg != gi106gyro_degrees && gi106obs_check == 0) gi106gyro_degrees = vor1_hdg;
			gi106obs_check = 0;

//Only set from here on if avionics bus is active

			if (avionics_on == 1)
			{

//Night
				if (lights_on == 1)
				{

					HIDE_LISTELEMENT(pgauge->elements_list[0],12);
					HIDE_LISTELEMENT(pgauge->elements_list[0],13);
					HIDE_LISTELEMENT(pgauge->elements_list[0],15);
					HIDE_LISTELEMENT(pgauge->elements_list[0],16);
					HIDE_LISTELEMENT(pgauge->elements_list[0],17);
					HIDE_LISTELEMENT(pgauge->elements_list[0],18);
					HIDE_LISTELEMENT(pgauge->elements_list[0],19);
					HIDE_LISTELEMENT(pgauge->elements_list[0],20);
					HIDE_LISTELEMENT(pgauge->elements_list[0],21);
									
					SHOW_LISTELEMENT(pgauge->elements_list[0],2);
					SHOW_LISTELEMENT(pgauge->elements_list[0],3);
					SHOW_LISTELEMENT(pgauge->elements_list[0],7);
					SHOW_LISTELEMENT(pgauge->elements_list[0],8);
					SHOW_LISTELEMENT(pgauge->elements_list[0],9);

//Set Glideslope flag

					lookup_var(&gflag);
					gs_active = gflag.var_value.n;
					if (gs_active == 0) SHOW_LISTELEMENT(pgauge->elements_list[0],11);
					else HIDE_LISTELEMENT(pgauge->elements_list[0],11);

//Set nav radial flag

					lookup_var(&vor1_str);
					vor1_sig = vor1_str.var_value.n;	
					if (vor1_sig == 0) SHOW_LISTELEMENT(pgauge->elements_list[0],10);
					else  HIDE_LISTELEMENT(pgauge->elements_list[0],10);

//Set to/from flags - notify strings to display TO FR

					lookup_var(&tf_flag);
					vor1_tf = tf_flag.var_value.e;
					if (vor1_tf == VOR_TF_FLAG_TO)
						SHOW_LISTELEMENT(pgauge->elements_list[0],6),
						HIDE_LISTELEMENT(pgauge->elements_list[0],5);
					else if (vor1_tf == VOR_TF_FLAG_FROM) 
						SHOW_LISTELEMENT(pgauge->elements_list[0],5),
						HIDE_LISTELEMENT(pgauge->elements_list[0],6);
					else
						HIDE_LISTELEMENT(pgauge->elements_list[0],5),
						HIDE_LISTELEMENT(pgauge->elements_list[0],6);
				}
				else
				if (lights_on == 0)
				{

					HIDE_LISTELEMENT(pgauge->elements_list[0],3);
					HIDE_LISTELEMENT(pgauge->elements_list[0],4);
					HIDE_LISTELEMENT(pgauge->elements_list[0],5);
					HIDE_LISTELEMENT(pgauge->elements_list[0],6);
					HIDE_LISTELEMENT(pgauge->elements_list[0],7);
					HIDE_LISTELEMENT(pgauge->elements_list[0],8);
					HIDE_LISTELEMENT(pgauge->elements_list[0],9);
					HIDE_LISTELEMENT(pgauge->elements_list[0],10);
					HIDE_LISTELEMENT(pgauge->elements_list[0],11);

									
					SHOW_LISTELEMENT(pgauge->elements_list[0],12);
					SHOW_LISTELEMENT(pgauge->elements_list[0],13);
					SHOW_LISTELEMENT(pgauge->elements_list[0],17);
					SHOW_LISTELEMENT(pgauge->elements_list[0],18);
					SHOW_LISTELEMENT(pgauge->elements_list[0],19);

//Set Glideslope flag

					lookup_var(&gflag);
					gs_active = gflag.var_value.n;
					if (gs_active == 0) SHOW_LISTELEMENT(pgauge->elements_list[0],21);
					else HIDE_LISTELEMENT(pgauge->elements_list[0],21);

//Set nav radial flag

					lookup_var(&vor1_str);
					vor1_sig = vor1_str.var_value.n;	
					if (vor1_sig == 0) SHOW_LISTELEMENT(pgauge->elements_list[0],20);
					else  HIDE_LISTELEMENT(pgauge->elements_list[0],20);

//Set to/from flags - notify strings to display TO FR

					lookup_var(&tf_flag);
					vor1_tf = tf_flag.var_value.e;
					if (vor1_tf == VOR_TF_FLAG_TO)
						SHOW_LISTELEMENT(pgauge->elements_list[0],16),
						HIDE_LISTELEMENT(pgauge->elements_list[0],15);
					else if (vor1_tf == VOR_TF_FLAG_FROM) 
						SHOW_LISTELEMENT(pgauge->elements_list[0],15),
						HIDE_LISTELEMENT(pgauge->elements_list[0],16);
					else
						HIDE_LISTELEMENT(pgauge->elements_list[0],15),
						HIDE_LISTELEMENT(pgauge->elements_list[0],16);
				}
			}

//Avionics bus off

			else
			{
				HIDE_LISTELEMENT(pgauge->elements_list[0],5),
				HIDE_LISTELEMENT(pgauge->elements_list[0],6);
				HIDE_LISTELEMENT(pgauge->elements_list[0],15),
				HIDE_LISTELEMENT(pgauge->elements_list[0],16);
				if (lights_on == 1)
				{
					SHOW_LISTELEMENT(pgauge->elements_list[0],21),
					SHOW_LISTELEMENT(pgauge->elements_list[0],20);
					HIDE_LISTELEMENT(pgauge->elements_list[0],11),
					HIDE_LISTELEMENT(pgauge->elements_list[0],10);
				}
				else
				{
					SHOW_LISTELEMENT(pgauge->elements_list[0],10),
					SHOW_LISTELEMENT(pgauge->elements_list[0],11);
					HIDE_LISTELEMENT(pgauge->elements_list[0],21),
					HIDE_LISTELEMENT(pgauge->elements_list[0],20);
				}
			}

		break;

/* "draw_routine()" */

		case    PANEL_SERVICE_PRE_DRAW:
		break;

/* "kill_routine()" */

		case    PANEL_SERVICE_PRE_KILL:
		break;
	}

}

/////////////////////////////////////////////////////////////////////////////
#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W

