#include "..\inc\gauges.h"
#include "..\inc\eventid.h"
#include "..\inc\dragonflight.h"
#include "..\inc\fssound.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "panswitch.h"

/***************** Global functions ***********************/

void FSAPI	add_imagedata_to_listelement(PELEMENT_HEADER	pelement,UINT32	pos_element,FLAGS image_flags);
void FSAPI	remove_imagedata_from_listelement(PELEMENT_HEADER	pelement,UINT32	pos_element,FLAGS image_flags);

PELEMENT_STATIC_IMAGE	pstat=NULL;	//Mouse background data


//****************** Sub-gauges ***********************//

#define		GAUGE_NAME			"psw0\0"
#define		GAUGEHDR_VAR_NAME	gaugehdr_p0
#define		GAUGE_W				38

#include "subgauges\pswitch0.c"

#define		GAUGE_NAME			"psw1\0"
#define		GAUGEHDR_VAR_NAME	gaugehdr_p1
#define		GAUGE_W				38

#include "subgauges\pswitch1.c"

//--------------------------------------------------------------
// Gauge table entries

GAUGE_TABLE_BEGIN()
	GAUGE_TABLE_ENTRY(&gaugehdr_p0)
	GAUGE_TABLE_ENTRY(&gaugehdr_p1)
GAUGE_TABLE_END()
