//Make_string colours
//Original flags for compatibility with first attempts

#define red RGB(255,0,0)
#define higreen RGB(0,255,0)
#define yellow RGB(255,255,0)
#define transp RGB(0,0,0)

//Preferred flags
#define collins RGB(255,64,0)
#define bright_red RGB(255,0,0)
#define orange RGB(255,128,0)
#define bright_green RGB(0,255,0)
#define blue RGB(0,0,255)
#define bright_yellow RGB(255,255,0)
#define trans_black RGB(0,0,0)
#define cyan RGB(0,255,255)
#define white RGB(255,255,255)
#define magenta RGB(255,0,255)
#define black RGB(8,8,8)

//Shortened macro flags
#define erase			BIT1
#define hidden			BIT30
#define hidden_tree		BIT25
#define bright			BIT2
#define transparent		BIT0
#define string_trans	BIT15
#define anti_alias		BIT7
#define luminous		BIT14
#define p_luminous		BIT15
#define alpha			BIT13
#define no_static		BIT4
#define alpha_mask		BIT12

//Font flags
#define def_char	DEFAULT_CHARSET
#define arial		"ARIAL"
#define courier_new	"COURIER_NEW"
#define tnr			"TIMES_NEW_ROMAN"
#define helvetica	"HELVETICA"
#define quartz		"QUARTZ"
#define glass		"GLASS GAUGE"
#define anbi		"ARIAL NARROW BOLD ITALIC"

#define normal		FW_NORMAL
#define bold		FW_BOLD


//**************************************************************************
//---------------------------------------------------------------------------

//Get VOR type
//Input required = vor1_code or vor2_code and flag to check
//See gauges.h for VOR CODE INFO FIELD

BOOL VorType(MODULE_VAR vorfield, FLAGS vorflag)
{
	if ((vorfield.var_value.b&vorflag)!= FLAGS0) return TRUE;
	else return FALSE;
}

