#ifdef __GNUC__
        #include "gccgauges.h"
#else
	#include "fs2kgauges.h"
#endif


#include "Registration.h"

#define		GAUGEHDR_VAR_NAME	gaugehdr_Registration
#define		GAUGE_ITEM			Registration
#define		GAUGE_NAME			"Registration\0"
#define		GAUGE_W				72

#define		GAUGE_CHARSET				DEFAULT_CHARSET
#define		GAUGE_FONT_DEFAULT			"Arial"

#define		GAUGE_WEIGHT_DEFAULT		FW_NORMAL


#define		BMP_BACK                BMP_BACK_REGISTRATION
#define		REF_HELPID			HELP_NONE

void	CheckOnChangedFontandColour( PGAUGEHDR pgauge);



char C_GAUGE(gauge_name)[]		= GAUGE_NAME;
extern PELEMENT_HEADER		C_GAUGE(list);
extern MOUSERECT			C_GAUGE(mouse_rect)[];

void FSAPI C_GAUGE(gauge_cb)( PGAUGEHDR pgauge, int service_id, UINT32 extra_data);


GAUGE_HEADER_FS700(GAUGE_W, C_GAUGE(gauge_name), &C_GAUGE(list),C_GAUGE(mouse_rect), &C_GAUGE(gauge_cb), 0, 0, 0);

MOUSE_BEGIN( C_GAUGE(mouse_rect), REF_HELPID, 0, 0 )
MOUSE_END

FLOAT64 FSAPI	C_GAUGE(string_cb)( PELEMENT_STRING pelement );

MAKE_STRING
(
	C_GAUGE(string),
	NULL,
	NULL,
	IMAGE_USE_ERASE|IMAGE_USE_TRANSPARENCY|BIT7,
	0,
	0, 0,
	72, 8,
	12,

	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	MODULE_VAR_NONE,
	RGB(255,255,255),
	RGB(0,0,0),
	RGB(92,92,92),
	GAUGE_FONT_DEFAULT,
	GAUGE_WEIGHT_DEFAULT,
	GAUGE_CHARSET,
	0,
	DT_CENTER | DT_VCENTER | DT_SINGLELINE,
	NULL,
	C_GAUGE(string_cb)
)

PELEMENT_HEADER C_GAUGE(plist1)[] =
{
   &C_GAUGE(string).header,
   NULL
};

MAKE_STATIC(    C_GAUGE(background),
                BMP_BACK,
                C_GAUGE(plist1),
                NULL,
                IMAGE_USE_TRANSPARENCY| IMAGE_USE_ERASE ,
                0,
                { 0, 0 } )

PELEMENT_HEADER C_GAUGE(list) = &C_GAUGE(background).header;
///////////////////////////////////////////////////////////////////////////////////////

void	CheckOnChangedFontandColour( PGAUGEHDR pgauge)
{			
	PELEMENT_STRING pelement=NULL;
	PCHAR	pchSearch=NULL,pchStartParams=NULL;
	UINT32	b4RedValue=0,b4GreenValue=0,b4BlueValue=0;

	if(pgauge==NULL)
		return;
	
	if(pgauge->parameters==NULL)
		return;
	pchStartParams=pgauge->parameters;
	if(strlen(pchStartParams)==0)
		return;

	if(pgauge->elements_list[0]==NULL)
		return;
	if(pgauge->elements_list[0]->next_element[0]==NULL)
		return;
	pelement=(PELEMENT_STRING)pgauge->elements_list[0]->next_element[0];

	if((pchStartParams=strchr(pchStartParams,' '))==NULL)//parameters after text start with ' '
		return;
	pchStartParams++;

//font 
	if((pchSearch=strchr(pchStartParams,'f'))!=NULL)
	{
		strcpy(pelement->font_name,pchSearch+1);
		*pchSearch=0;//cut away font entry
	}

//colours
	//red
	b4RedValue=GetRValue(pelement->fg_color);
	if((pchSearch=strchr(pchStartParams,'r'))!=NULL)
		b4RedValue=atoi(pchSearch+1);
	if(b4RedValue>255)
		b4RedValue=255;
	//green
	b4GreenValue=GetGValue(pelement->fg_color);
	if((pchSearch=strchr(pchStartParams,'g'))!=NULL)
		b4GreenValue=atoi(pchSearch+1);
	if(b4GreenValue>255)
		b4GreenValue=255;
	//blue
	b4BlueValue=GetBValue(pelement->fg_color);
	if((pchSearch=strchr(pchStartParams,'b'))!=NULL)
		b4BlueValue=atoi(pchSearch+1);
	if(b4BlueValue>255)
		b4BlueValue=255;

	pelement->fg_color=RGB(b4RedValue,b4GreenValue,b4BlueValue);

}

void FSAPI C_GAUGE(gauge_cb)( PGAUGEHDR pgauge, int service_id, UINT32 extra_data)
{
	switch(service_id)
	{
		case	PANEL_SERVICE_PRE_INSTALL:
			CheckOnChangedFontandColour( pgauge);
			break;
	}
}

FLOAT64 FSAPI	C_GAUGE(string_cb)( PELEMENT_STRING pelement )
{
	PCHAR	pchRegisterString=(PCHAR)pelement->gauge_header->parameters;
	PCHAR	pchSearch=NULL;
	if((pchSearch=strchr(pchRegisterString,'t'))!=pchRegisterString)
		wsprintf(pelement->string, "N700MS");
	else
		wsprintf(pelement->string, "%s",pchSearch+1);
	if((pchSearch=strchr(pelement->string,' '))!=NULL)//cut after first space
		*pchSearch=0;
	while((pchSearch=strchr(pelement->string,'_'))!=NULL)//change _ to space
		*pchSearch=' ';

	return	pelement->source_var[0].var_value.n;
}


#undef		REF_HELPID
#undef		BITMAP_BACK


#undef		GAUGE_CHARSET
#undef		GAUGE_FONT_DEFAULT
#undef		GAUGE_WEIGHT_DEFAULT

#undef		GAUGE_ITEM
#undef		GAUGE_NAME
#undef		GAUGEHDR_VAR_NAME
#undef		GAUGE_W

GAUGE_TABLE_BEGIN()
	GAUGE_TABLE_ENTRY(&gaugehdr_Registration)
GAUGE_TABLE_END()

