// SDK.Magnetos.h
// Copyright (c) 1997 Microsoft Corporation.  All rights reserved.
//
// Adapted to use the FSSound module by Daniel Steiner
//

#define         VERSION_MAJOR           1
#define         VERSION_MINOR           0
#define         VERSION_BUILD           0

// magic to get the preprocessor to do what we want
#define		lita(arg) #arg
#define		xlita(arg) lita(arg)
#define		cat3(w,x,z) w##.##x##.##z##\000
#define		xcat3(w,x,z) cat3(w,x,z)
#define		VERSION_STRING xlita(xcat3(VERSION_MAJOR,VERSION_MINOR,VERSION_BUILD))

#ifndef		VS_VERSION_INFO
#define		VS_VERSION_INFO		0x0001
#endif

#define		BMP_BACKGROUND			0x1000
#define		BMP_MAGNETO_DOWN		0x2000
#define		BMP_MAGNETO_UP			0x2003

// use any (otherwise unused) resource id for sound resources
#define     SND_MARKER              0x3000
