//REPLACE gi102 WITH GAUGENAME

char gi102_gauge_name[]		= GAUGE_NAME;
extern PELEMENT_HEADER		gi102_list;
extern MOUSERECT			gi102_mouse_rect[];
GAUGE_CALLBACK				gi102_update;
GAUGE_HEADER_FS700(GAUGE_W, gi102_gauge_name, &gi102_list, gi102_mouse_rect, gi102_update, 0,0,0 );

FAILURE_RECORD	gi102_fail2[] =
{
	{FAIL_GAUGE_NAVIGATION, FAIL_ACTION_FREEZE},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

//******* Day

NONLINEARITY gi102card_needle_nl[] =
{
	{{7,	 125},	  270.000000, 0},
	{{127,	 0},	  180.000000, 0},
	{{250,	 125},	  90.000000, 0},
	{{126,	 243},	  0.000000, 0},
};

//********** Night

NONLINEARITY gi102card_night_needle_nl[] =
{
	{{7,	 125},	  270.000000, 0},
	{{127,	 0},	  180.000000, 0},
	{{250,	 125},	  90.000000, 0},
	{{126,	 243},	  0.000000, 0},
};


MOUSE_FUNCTION gi102_obs_up_mcb;
MOUSE_FUNCTION gi102_obs_dn_mcb;
MOUSE_FUNCTION gi102_degrees_mcb;

MOUSE_BEGIN( gi102_mouse_rect, 0, 0, 0 )

    MOUSE_CHILD_FUNCT( 13, 200, 23, 44, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, gi102_obs_dn_mcb)
    MOUSE_CHILD_FUNCT( 37, 200, 23, 44, CURSOR_UPARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, gi102_obs_up_mcb)
    MOUSE_CHILD_FUNCT( 68, 150, 38, 30, CURSOR_HAND, MOUSE_LEFTSINGLE, gi102_degrees_mcb)

MOUSE_END

SINT32 gi102obs_count = 0;

UINT32 gi102gyro_degrees = 0;
UINT32 gi102show_deg = 0;
UINT32 gi102obs_check = 0;

//****** Day

STRING_UPDATE_CALLBACK gi102deg_string_cb;
NEEDLE_UPDATE_CALLBACK gi102card_needle_cb;
SLIDER_UPDATE_CALLBACK gi102nav_slider_cb;

//****** Night

STRING_UPDATE_CALLBACK gi102deg_night_string_cb;
NEEDLE_UPDATE_CALLBACK gi102card_night_needle_cb;
SLIDER_UPDATE_CALLBACK gi102nav_night_slider_cb;

NEEDLE_UPDATE_CALLBACK gi102obs_needle_cb;

double gi102_nav = 0;

/*********************** Day display ***************************/


MAKE_ICON(		gi102navflag_icon,
				GI_NAV,
				NULL,
				gi102_fail2,
				hidden | erase | transparent,
				0,
				115,199,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi102_plist1[] =
{
	&gi102navflag_icon.header,
	NULL
};


//LOC needle


MAKE_SLIDER(    gi102loc_slider,
                GI_VERT,
                &gi102_plist1,
                gi102_fail2,
				hidden | erase | transparent | anti_alias,
                0,
                127, 60,
                MODULE_VAR_NONE, gi102nav_slider_cb, 0.5,
                MODULE_VAR_NONE, NULL, 0.000000)

PELEMENT_HEADER		gi102_plist2[] =
{
	&gi102loc_slider.header,
	NULL
};

MAKE_ICON(		gi102yellowflag_icon,
				GI_POINTER,
				&gi102_plist2,
				NULL,
				hidden | erase | transparent,
				0,
				119,45,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi102_plist3[] =
{
	&gi102yellowflag_icon.header,
	NULL
};


MAKE_ICON(		gi102to_flag_icon,
				GI_TO_FLAG,
				&gi102_plist3,
				gi102_fail2,
				hidden | erase | transparent,
				0,
				156,86,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi102_plist4[] =
{
	&gi102to_flag_icon.header,
	NULL
};


MAKE_ICON(		gi102from_flag_icon,
				GI_FROM_FLAG,
				&gi102_plist4,
				gi102_fail2,
				hidden | erase | transparent,
				0,
				156,86,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi102_plist5[] =
{
	&gi102from_flag_icon.header,
	NULL
};

MAKE_STRING(	gi102deg_string,
				&gi102_plist5,
				gi102_fail2,
				hidden | erase  | string_trans,
				0,
				60, 143,
                50, 30,
				3,
				MODULE_VAR_NONE,
				MODULE_VAR_NONE,
				MODULE_VAR_NONE,
				white,
				trans_black,
				yellow,
				arial,
				normal,
				def_char,
				0,
				DT_CENTER | DT_VCENTER | DT_SINGLELINE,
				NULL,
				gi102deg_string_cb )

PELEMENT_HEADER		gi102_plist6[] =
{
	&gi102deg_string.header,
	NULL
};


MAKE_ICON(		gi102dots_icon,
				GI_VOR_DOTS,
				&gi102_plist6,
				NULL,
				hidden | erase | transparent,
				0,
				50,50,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi102_plist7[] =
{
	&gi102dots_icon.header,
	NULL
};


MAKE_NEEDLE(    gi102card_needle,
                GI_GYRO,
                &gi102_plist7,
                NULL,
				erase | transparent | anti_alias,
                0,
                127, 127,
				112, 112,
				AIRSPEED,
				gi102card_needle_cb,
                gi102card_needle_nl,
                0 )

PELEMENT_HEADER		gi102_plist8[] =
{
	&gi102card_needle.header,
	NULL
};

/**************************** Night display ************************/

MAKE_ICON(		gi102navflag_night_icon,
				GI_NAV,
				&gi102_plist8,
				gi102_fail2,
				luminous | hidden | erase | transparent,
				0,
				115,199,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi102_plist9[] =
{
	&gi102navflag_night_icon.header,
	NULL
};

//LOC needle


MAKE_SLIDER(    gi102loc_night_slider,
                GI_VERT,
                &gi102_plist9,
                gi102_fail2,
				luminous | hidden | erase | transparent | anti_alias,
                0,
                127, 60,
                MODULE_VAR_NONE, gi102nav_night_slider_cb, 0.5,
                MODULE_VAR_NONE, NULL, 0.000000)

PELEMENT_HEADER		gi102_plist10[] =
{
	&gi102loc_night_slider.header,
	NULL
};

MAKE_ICON(		gi102yellowflag_night_icon,
				GI_POINTER,
				&gi102_plist10,
				NULL,
				luminous | hidden | erase | transparent,
				0,
				119,45,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi102_plist11[] =
{
	&gi102yellowflag_night_icon.header,
	NULL
};


MAKE_ICON(		gi102to_flag_night_icon,
				GI_TO_FLAG,
				&gi102_plist11,
				gi102_fail2,
				luminous | hidden | erase | transparent,
				0,
				156,86,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi102_plist12[] =
{
	&gi102to_flag_night_icon.header,
	NULL
};


MAKE_ICON(		gi102from_flag_night_icon,
				GI_FROM_FLAG,
				&gi102_plist12,
				gi102_fail2,
				luminous | hidden | erase | transparent,
				0,
				156,86,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi102_plist13[] =
{
	&gi102from_flag_night_icon.header,
	NULL
};

MAKE_STRING(	gi102deg_night_string,
				&gi102_plist13,
				gi102_fail2,
				luminous | erase | string_trans,
				0,
				60, 143,
                50, 30,
				3,
				MODULE_VAR_NONE,
				MODULE_VAR_NONE,
				MODULE_VAR_NONE,
				white,
				trans_black,
				yellow,
				arial,
				normal,
				def_char,
				0,
				DT_CENTER | DT_VCENTER | DT_SINGLELINE,
				NULL,
				gi102deg_night_string_cb )

PELEMENT_HEADER		gi102_plist14[] =
{
	&gi102deg_night_string.header,
	NULL
};


MAKE_ICON(		gi102dots_night_icon,
				GI_VOR_DOTS,
				&gi102_plist14,
				NULL,
				luminous | hidden | erase | transparent,
				0,
				50,50,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		gi102_plist15[] =
{
	&gi102dots_night_icon.header,
	NULL
};


MAKE_NEEDLE(    gi102card_night_needle,
                GI_GYRO,
                &gi102_plist15,
                NULL,
				luminous | hidden | erase | transparent | anti_alias,
                0,
                127, 127,
				112, 112,
				AIRSPEED,
				gi102card_night_needle_cb,
                gi102card_night_needle_nl,
                0 )

PELEMENT_HEADER		gi102_plist16[] =
{
	&gi102card_night_needle.header,
	NULL
};

//Dark background

MAKE_NEEDLE(    gi102obs_needle,
                GI_OBS,
                &gi102_plist16,
                NULL,
				erase | transparent | anti_alias,
                0,
                36, 222,
				20, 20,
				AIRSPEED,			//Dummy for anti-clockwise movement
				gi102obs_needle_cb,
				NULL,
                0 )

PELEMENT_HEADER		gi102_plist17[] =
{
	&gi102obs_needle.header,
	NULL
};

MAKE_STATIC (	gi102_static,
				GI_BG,
				&gi102_plist17,
				NULL,
				erase | transparent,
				0,
				0,0 )

PELEMENT_HEADER	gi102_list	= &gi102_static.header;

//---------------------------------------------------------------------------
//****************** Day callbacks ***********************//
//---------------------------------------------------------------------------
FLOAT64 FSAPI gi102nav_slider_cb (PELEMENT_SLIDER pelement )
{
	lookup_var(&deviation2);
	if (avionics_on == 1) gi102_nav = deviation2.var_value.n;
	else gi102_nav = 0;
	return gi102_nav;
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI gi102obs_needle_cb (PELEMENT_NEEDLE pelement )
{
	FLOAT64	val = pelement->source_var.var_value.n;

	return gi102gyro_degrees;
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI gi102card_needle_cb (PELEMENT_NEEDLE pelement )
{
	FLOAT64	val = pelement->source_var.var_value.n;

	return gi102gyro_degrees;
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI	gi102deg_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64	val = pelement->source_var[0].var_value.n;
	val = !val;

	if (gi102show_deg == 1) wsprintf(pelement->string, "%3d", gi102gyro_degrees);
	else wsprintf(pelement->string, "%3s", "");

	return val;
}
//---------------------------------------------------------------------------
//************************** Night callbacks ***********************//
//---------------------------------------------------------------------------
FLOAT64 FSAPI gi102nav_night_slider_cb (PELEMENT_SLIDER pelement )
{
	lookup_var(&deviation2);
	if (avionics_on == 1) gi102_nav = deviation2.var_value.n;
	else gi102_nav = 0;
	return gi102_nav;
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI gi102obs_night_needle_cb (PELEMENT_NEEDLE pelement )
{
	FLOAT64	val = pelement->source_var.var_value.n;

	return gi102obs_count;
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI gi102card_night_needle_cb (PELEMENT_NEEDLE pelement )
{
	FLOAT64	val = pelement->source_var.var_value.n;

	return gi102gyro_degrees;
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI	gi102deg_night_string_cb(PELEMENT_STRING pelement)
{
	FLOAT64	val = pelement->source_var[0].var_value.n;
	val = !val;

	if (gi102show_deg == 1) wsprintf(pelement->string, "%3d", gi102gyro_degrees);
	else wsprintf(pelement->string, "%3s", "");

	return val;
}
//---------------------------------------------------------------------------
//************************* External callbacks ***********************//
//---------------------------------------------------------------------------
BOOL FSAPI gi102_obs_up_mcb( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{
	if (gi102obs_count + 1 > 359) gi102obs_count = 0;
	else gi102obs_count++;

	if (gi102gyro_degrees + 1 > 359) gi102gyro_degrees = 0;
	else gi102gyro_degrees++;

	trigger_key_event(KEY_VOR2_SET, gi102gyro_degrees);

	gi102obs_check = 1;

	return FALSE;
}
//---------------------------------------------------------------------------
BOOL FSAPI gi102_obs_dn_mcb( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{
	if (gi102obs_count - 1 == -1) gi102obs_count = 359;
	else gi102obs_count--;

	if (gi102gyro_degrees - 1 == -1) gi102gyro_degrees = 359;
	else gi102gyro_degrees--;

	trigger_key_event(KEY_VOR2_SET, gi102gyro_degrees);

	gi102obs_check = 1;

	return FALSE;
}
//---------------------------------------------------------------------------
BOOL FSAPI gi102_degrees_mcb( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{

	if (gi102show_deg == 0) gi102show_deg = 1;
	else gi102show_deg = 0;

	return FALSE;
}
//---------------------------------------------------------------------------
void FSAPI	gi102_update (PGAUGEHDR pgauge, int service_id, UINT32 extra_data)
{
	switch(service_id)
	{

/* "install_routine()" */

		case    PANEL_SERVICE_PRE_INSTALL:
		break;

/* "initialize_routine()" */

		case    PANEL_SERVICE_PRE_INITIALIZE:
		break;

/* "update_routine()" */

		case    PANEL_SERVICE_PRE_UPDATE:

//Check for active power buses

			lookup_var(&avionics_circuit_on);
			lookup_var(&navlights_on);
			avionics_on = avionics_circuit_on.var_value.n;
			lights_on = navlights_on.var_value.n;

//Set OBI heading - this checks for a change in the menus too

			lookup_var(&heading2);
			vor2_hdg = heading2.var_value.n;
			if (vor2_hdg != gi102gyro_degrees && gi102obs_check == 0) gi102gyro_degrees = vor2_hdg;
			gi102obs_check = 0;

//Only set from here on if avionics bus is active

			if (avionics_on == 1)
			{

//Night
				if (lights_on == 1)
				{

					HIDE_LISTELEMENT(pgauge->elements_list[0],10);
					HIDE_LISTELEMENT(pgauge->elements_list[0],11);
					HIDE_LISTELEMENT(pgauge->elements_list[0],13);
					HIDE_LISTELEMENT(pgauge->elements_list[0],14);
					HIDE_LISTELEMENT(pgauge->elements_list[0],15);
					HIDE_LISTELEMENT(pgauge->elements_list[0],16);
					HIDE_LISTELEMENT(pgauge->elements_list[0],17);

									
					SHOW_LISTELEMENT(pgauge->elements_list[0],2);
					SHOW_LISTELEMENT(pgauge->elements_list[0],3);
					SHOW_LISTELEMENT(pgauge->elements_list[0],7);
					SHOW_LISTELEMENT(pgauge->elements_list[0],8);

//Set nav radial flag

					lookup_var(&vor2_str);
					vor2_sig = vor2_str.var_value.n;	
					if (vor2_sig == 0) SHOW_LISTELEMENT(pgauge->elements_list[0],9);
					else  HIDE_LISTELEMENT(pgauge->elements_list[0],9);

//Set to/from flags - notify strings to display TO FR

					lookup_var(&tf_flag2);
					vor2_tf = tf_flag2.var_value.e;
					if (vor2_tf == VOR_TF_FLAG_TO)
						SHOW_LISTELEMENT(pgauge->elements_list[0],6),
						HIDE_LISTELEMENT(pgauge->elements_list[0],5);
					else if (vor2_tf == VOR_TF_FLAG_FROM) 
						SHOW_LISTELEMENT(pgauge->elements_list[0],5),
						HIDE_LISTELEMENT(pgauge->elements_list[0],6);
					else
						HIDE_LISTELEMENT(pgauge->elements_list[0],5),
						HIDE_LISTELEMENT(pgauge->elements_list[0],6);
						
				}
				else
				if (lights_on == 0)
				{

					HIDE_LISTELEMENT(pgauge->elements_list[0],3);
					HIDE_LISTELEMENT(pgauge->elements_list[0],4);
					HIDE_LISTELEMENT(pgauge->elements_list[0],5);
					HIDE_LISTELEMENT(pgauge->elements_list[0],6);
					HIDE_LISTELEMENT(pgauge->elements_list[0],7);
					HIDE_LISTELEMENT(pgauge->elements_list[0],8);
					HIDE_LISTELEMENT(pgauge->elements_list[0],9);
									
					SHOW_LISTELEMENT(pgauge->elements_list[0],10);
					SHOW_LISTELEMENT(pgauge->elements_list[0],11);
					SHOW_LISTELEMENT(pgauge->elements_list[0],15);
					SHOW_LISTELEMENT(pgauge->elements_list[0],16);

//Set nav radial flag

					lookup_var(&vor2_str);
					vor2_sig = vor2_str.var_value.n;	
					if (vor2_sig == 0) SHOW_LISTELEMENT(pgauge->elements_list[0],17);
					else  HIDE_LISTELEMENT(pgauge->elements_list[0],17);

//Set to/from flags - notify strings to display TO FR

					lookup_var(&tf_flag2);
					vor2_tf = tf_flag2.var_value.e;
					if (vor2_tf == VOR_TF_FLAG_TO)
						SHOW_LISTELEMENT(pgauge->elements_list[0],14),
						HIDE_LISTELEMENT(pgauge->elements_list[0],13);
					else if (vor2_tf == VOR_TF_FLAG_FROM) 
						SHOW_LISTELEMENT(pgauge->elements_list[0],13),
						HIDE_LISTELEMENT(pgauge->elements_list[0],14);
					else
						HIDE_LISTELEMENT(pgauge->elements_list[0],13),
						HIDE_LISTELEMENT(pgauge->elements_list[0],14);
				}

			}

//Avionics bus off

			else
			{
				HIDE_LISTELEMENT(pgauge->elements_list[0],5),
				HIDE_LISTELEMENT(pgauge->elements_list[0],6);
				HIDE_LISTELEMENT(pgauge->elements_list[0],13),
				HIDE_LISTELEMENT(pgauge->elements_list[0],14);
				if (lights_on == 1)
				{
					SHOW_LISTELEMENT(pgauge->elements_list[0],9),
					HIDE_LISTELEMENT(pgauge->elements_list[0],16);
				}
				else
				{
					SHOW_LISTELEMENT(pgauge->elements_list[0],16),
					HIDE_LISTELEMENT(pgauge->elements_list[0],9);
				}
			}

		break;

/* "draw_routine()" */

		case    PANEL_SERVICE_PRE_DRAW:
		break;

/* "kill_routine()" */

		case    PANEL_SERVICE_PRE_KILL:
		break;
	}

}

/////////////////////////////////////////////////////////////////////////////
#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W

