char p1_gauge_name[]		= GAUGE_NAME;
extern PELEMENT_HEADER		p1_list;
extern MOUSERECT			p1_mouse_rect[];
GAUGE_CALLBACK				p1_update;
GAUGE_HEADER_FS700(GAUGE_W, p1_gauge_name, &p1_list, p1_mouse_rect, p1_update, 0,0,0 );

FAILURE_RECORD	p1_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_ZERO},
	{FAIL_NONE, FAIL_ACTION_NONE}
};


MOUSE_FUNCTION p1_switch_mcb;

MOUSE_BEGIN( p1_mouse_rect, 0, 0, 0 )

    MOUSE_CHILD_FUNCT( 0, 0, 43, 73, CURSOR_UPARROW, MOUSE_LEFTSINGLE, p1_switch_mcb)

MOUSE_END

UINT32 p1_sw = 0;

MAKE_ICON(		p1_on_icon,
				PANEL_SW_ON,
				NULL,
				NULL,
				erase | transparent | hidden,
				0,
				0,0,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		p1_plist1[] =
{
	&p1_on_icon.header,
	NULL
};


MAKE_ICON(		p1_off_icon,
				PANEL_SW_OFF,
				&p1_plist1,
				NULL,
				erase | transparent,
				0,
				0,0,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0 )

PELEMENT_HEADER		p1_plist2[] =
{
	&p1_off_icon.header,
	NULL
};

MAKE_STATIC (	p1_off_static,
				PANEL_SW_BG,
				&p1_plist2,
				NULL,
				erase | transparent,
				0,
				0,0 )

PELEMENT_HEADER	p1_list	= &p1_off_static.header;

//NOTE!!! The sound name has changed here but the wav file is the same.
//If you do not change the sound name then the compiler will throw an error.
//This way each subgauge controls its own click sound.

MFSSoundFileVars(click1, "Sound\\360smtog.wav");


//---------------------------------------------------------------------------
BOOL FSAPI p1_switch_mcb( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{
	if (p1_sw == 0) p1_sw = 1;
	else p1_sw = 0;

	MFSSoundFilePlay(click1, FALSE);

	trigger_key_event(KEY_PANEL_3,0);

	return FALSE;
}
//---------------------------------------------------------------------------
void FSAPI	p1_update (PGAUGEHDR pgauge, int service_id, UINT32 extra_data)
{
	switch(service_id)
	{

		case    PANEL_SERVICE_PRE_INSTALL:

		MFSSoundFileRegister(click1);

		break;

		case    PANEL_SERVICE_PRE_INITIALIZE:
		break;

		case    PANEL_SERVICE_PRE_UPDATE:

		if (p1_sw == 1) 
		{		
			SHOW_LISTELEMENT(pgauge->elements_list[0],2);
			HIDE_LISTELEMENT(pgauge->elements_list[0],1);
		}
		else
		{		
			SHOW_LISTELEMENT(pgauge->elements_list[0],1);
			HIDE_LISTELEMENT(pgauge->elements_list[0],2);
		}
			
		break;

		case    PANEL_SERVICE_PRE_DRAW:
		break;

		case    PANEL_SERVICE_PRE_KILL:

		MFSSoundUnregister(click1);

		break;
	}

}

/////////////////////////////////////////////////////////////////////////////
#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W

