//REPLACE clock WITH GAUGENAME

char clock_gauge_name[]		= GAUGE_NAME;
extern PELEMENT_HEADER		clock_list;
extern MOUSERECT			clock_mouse_rect[];
GAUGE_CALLBACK				clock_update;
GAUGE_HEADER_FS700(GAUGE_W, clock_gauge_name, &clock_list, clock_mouse_rect, clock_update, 0,0,0 );

FAILURE_RECORD	clock_fail[] =
{
	{FAIL_SYSTEM_ELECTRICAL_PANELS, FAIL_ACTION_ZERO},
	{FAIL_NONE, FAIL_ACTION_NONE}
};

MOUSE_FUNCTION	clock_time_plus;
MOUSE_FUNCTION	clock_time_minus;

MOUSE_BEGIN( clock_mouse_rect, 0, 0, 0 )

    MOUSE_CHILD_FUNCT( 0, 245, 35, 60, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, clock_time_minus )
    MOUSE_CHILD_FUNCT( 36, 245, 35, 60, CURSOR_UPARROW, MOUSE_LEFTSINGLE | MOUSE_DOWN_REPEAT, clock_time_plus )

MOUSE_END

NONLINEARITY  hour_hand[] =

{
	{{157,	40},	 0.000000,   0},
	{{100,	57},	 11.000000,   0},
};

NONLINEARITY  minute_hand[] =

{
	{{157,	40},	 0.000000,   0},
	{{144,	41},	 59.000000,   0},
};

NONLINEARITY  second_hand[] =

{
	{{157,	40},	 0.000000,   0},
	{{144,	41},	 59.000000,   0},
};

NONLINEARITY  hour_hand_night[] =

{
	{{157,	40},	 0.000000,   0},
	{{100,	57},	 11.000000,   0},
};

NONLINEARITY  minute_hand_night[] =

{
	{{157,	40},	 0.000000,   0},
	{{144,	41},	 59.000000,   0},
};

NONLINEARITY  second_hand_night[] =

{
	{{157,	40},	 0.000000,   0},
	{{144,	41},	 59.000000,   0},
};

NEEDLE_UPDATE_CALLBACK	hour_cb;
NEEDLE_UPDATE_CALLBACK	minute_cb;
NEEDLE_UPDATE_CALLBACK	second_cb;

NEEDLE_UPDATE_CALLBACK	hour_cb_night;
NEEDLE_UPDATE_CALLBACK	minute_cb_night;
NEEDLE_UPDATE_CALLBACK	second_cb_night;


MAKE_NEEDLE(    clock_seconds,
                CLOCK_BMP_SECOND,
                NULL,
                clock_fail,
                transparent | erase | anti_alias,
                0,
                154, 153,
				0, 2,
				MODULE_VAR_NONE,
				second_cb,
                second_hand,
                0 )

PELEMENT_HEADER		clock_plist1[] =
{
	&clock_seconds.header,
	NULL
};


MAKE_NEEDLE(    clock_seconds_night,
                CLOCK_BMP_SECOND,
                &clock_plist1,
                clock_fail,
                transparent | erase | anti_alias | hidden | bright,
                0,
                154, 153,
				0, 2,
				MODULE_VAR_NONE,
				second_cb_night,
                second_hand_night,
                0 )

PELEMENT_HEADER		clock_plist2[] =
{
	&clock_seconds_night.header,
	NULL
};

MAKE_NEEDLE(    clock_minutes,
                CLOCK_BMP_MINUTE,
                &clock_plist2,
                clock_fail,
                transparent | erase | anti_alias,
                0,
                154, 153,
				0, 5,
				MODULE_VAR_NONE,
				minute_cb,
                minute_hand,
                0 )

PELEMENT_HEADER		clock_plist3[] =
{
	&clock_minutes.header,
	NULL
};


MAKE_NEEDLE(    clock_minutes_night,
                CLOCK_BMP_MINUTE,
                &clock_plist3,
                clock_fail,
                transparent | erase | anti_alias | bright | hidden,
                0,
                154, 153,
				0, 5,
				MODULE_VAR_NONE,
				minute_cb_night,
                minute_hand_night,
                0 )

PELEMENT_HEADER		clock_plist4[] =
{
	&clock_minutes_night.header,
	NULL
};

MAKE_NEEDLE(    clock_hours,
                CLOCK_BMP_HOUR,
                &clock_plist4,
                clock_fail,
                transparent | erase | anti_alias,
                0,
                154, 153,
				0, 8,
				MODULE_VAR_NONE,
				hour_cb,
                hour_hand,
                0 )

PELEMENT_HEADER		clock_plist5[] =
{
	&clock_hours.header,
	NULL
};


MAKE_NEEDLE(    clock_hours_night,
                CLOCK_BMP_HOUR,
                &clock_plist5,
                clock_fail,
                transparent | erase | anti_alias | bright | hidden,
                0,
                154, 153,
				0, 8,
				MODULE_VAR_NONE,
				hour_cb_night,
                hour_hand_night,
                0 )

PELEMENT_HEADER		clock_plist6[] =
{
	&clock_hours_night.header,
	NULL
};


MAKE_ICON(		clock_face,
				CLOCK_BMP_FACE,
				&clock_plist6,
				NULL,
                transparent | erase,
				0,
				0,0,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0, )

PELEMENT_HEADER		clock_plist7[] =
{
	&clock_face.header,
	NULL
};


MAKE_ICON(		clock_face_night,
				CLOCK_BMP_FACE,
				&clock_plist7,
				NULL,
                transparent | erase | anti_alias | hidden | bright,
				0,
				0,0,
				MODULE_VAR_NONE, NULL,
				ICON_SWITCH_TYPE_SET_CUR_ICON,
				1,
				0,
				0, )

PELEMENT_HEADER		clock_plist8[] =
{
	&clock_face_night.header,
	NULL
};

MAKE_STATIC(	clock_background,
				CLOCK_BMP_BACKGROUND,
				&clock_plist8,
				NULL,
                transparent | erase,
				0,
				0, 0 )

PELEMENT_HEADER		clock_list	= &clock_background.header;

//---------------------------------------------------------------------------
FLOAT64 FSAPI second_cb (PELEMENT_NEEDLE pelement)

{
	lookup_var(&second);
	return second.var_value.n; 
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI second_cb_night (PELEMENT_NEEDLE pelement)

{
	lookup_var(&second);
	return second.var_value.n; 
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI minute_cb (PELEMENT_NEEDLE pelement)

{
	lookup_var(&minute);
	return minute.var_value.n; 
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI minute_cb_night (PELEMENT_NEEDLE pelement)

{
	lookup_var(&minute);
	return minute.var_value.n; 
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI hour_cb (PELEMENT_NEEDLE pelement)

{
	lookup_var(&hour);
	if (hour.var_value.n > 12) hour.var_value.n = hour.var_value.n - 12;

	return hour.var_value.n; 
}
//---------------------------------------------------------------------------
FLOAT64 FSAPI hour_cb_night (PELEMENT_NEEDLE pelement)

{
	lookup_var(&hour);
	if (hour.var_value.n > 12) hour.var_value.n = hour.var_value.n - 12;

	return hour.var_value.n; 
}

//---------------------------------------------------------------------------

BOOL FSAPI clock_time_plus( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{
	trigger_key_event(KEY_CLOCK_MINUTES_INC,0);

	lookup_var(&minute);
	if (minute.var_value.n == 0) trigger_key_event(KEY_CLOCK_HOURS_INC,0);

	return FALSE;
}
//---------------------------------------------------------------------------

BOOL FSAPI clock_time_minus( PPIXPOINT relative_point, FLAGS32 mouse_flags )
{
	trigger_key_event(KEY_CLOCK_MINUTES_DEC,0);

	lookup_var(&minute);
	if (minute.var_value.n == 0) trigger_key_event(KEY_CLOCK_HOURS_DEC,0);

	return FALSE;
}

//---------------------------------------------------------------------------
void FSAPI	clock_update (PGAUGEHDR pgauge, int service_id, UINT32 extra_data)
{
	switch(service_id)
	{

/* "install_routine()" */

		case    PANEL_SERVICE_PRE_INSTALL:
		break;

/* "initialize_routine()" */

		case    PANEL_SERVICE_PRE_INITIALIZE:
		break;

/* "update_routine()" */

		case    PANEL_SERVICE_PRE_UPDATE:

//day/night
			lookup_var(&avlights);
			if (avlights.var_value.n != 0) clk_lights_on = 1;
			else clk_lights_on = 0;

			if (clk_lights_on == 1 )
			{
				SHOW_LISTELEMENT(pgauge->elements_list[0],1);
				SHOW_LISTELEMENT(pgauge->elements_list[0],3);
				SHOW_LISTELEMENT(pgauge->elements_list[0],5);
				SHOW_LISTELEMENT(pgauge->elements_list[0],7);
				HIDE_LISTELEMENT(pgauge->elements_list[0],2);
				HIDE_LISTELEMENT(pgauge->elements_list[0],4);
				HIDE_LISTELEMENT(pgauge->elements_list[0],6);
				HIDE_LISTELEMENT(pgauge->elements_list[0],8);
			}
			else
			{
				SHOW_LISTELEMENT(pgauge->elements_list[0],2);
				SHOW_LISTELEMENT(pgauge->elements_list[0],4);
				SHOW_LISTELEMENT(pgauge->elements_list[0],6);
				SHOW_LISTELEMENT(pgauge->elements_list[0],8);
				HIDE_LISTELEMENT(pgauge->elements_list[0],1);
				HIDE_LISTELEMENT(pgauge->elements_list[0],3);
				HIDE_LISTELEMENT(pgauge->elements_list[0],5);
				HIDE_LISTELEMENT(pgauge->elements_list[0],7);
			}

		break;

/* "draw_routine()" */

		case    PANEL_SERVICE_PRE_DRAW:
		break;

/* "kill_routine()" */

		case    PANEL_SERVICE_PRE_KILL:
		break;
	}

}

/////////////////////////////////////////////////////////////////////////////
#undef GAUGE_NAME
#undef GAUGEHDR_VAR_NAME
#undef GAUGE_W

